
.386p

_DATA SEGMENT PAGE PUBLIC 'DATA'                  

EXTRN      C   virtual: DWORD;

EXTRN      C   zoom_start_x: DWORD;
EXTRN      C   zoom_start_y: DWORD;
EXTRN      C   zoom_width: DWORD;

EXTRN      C   graphics_system:DWORD;

XR equ [graphics_system];   xresolution
YR equ [graphics_system+4]; yresolution
YS equ [graphics_system+8];   bytes_scanline

;----constantes de ASM

;----variables de ASM
FPUTemp1        dd      ?
FPUTemp2        dd      ?
FPUTemp3        dd      ?

virtual2        dd      ?
 
_DATA ENDS


_TEXT SEGMENT PAGE PUBLIC 'CODE'
	assume cs:_text, ds:_data

	PUBLIC          zoom_frame_asm_16_
	PUBLIC          zoom_frame_asm_15_

zoom_frame_asm_16_         PROC

;esi=virtual2;
;eax=i;
;edi=j;
;ebx=istep;
;edx=jstep;
;
;for (y=0; y<h; y++, j+=jstep)
;    for (x=0, i=((wt-w)>>1)*istep; x<w; x++, i+=istep) { 
;    temp=*((WORD *)(virtual2+(DWORD)(j)*w*2+(DWORD)(i)*2));
;    pPixel_16 (virtual+x*2 + w*y*2, temp);
;    }
;}
	
	push    ebp;    

	mov     virtual2, eax;

	mov     edx, YR;
	mov     edi, virtual;
	mov     esi, virtual2; solo pa probar (borrable)

	mov     eax, YS
	mov     FPUTemp1, eax;
	
	mov     eax, 0;
	mov     ebp, 0;

@@vertical:
	mov     ecx, zoom_width;
	push    edx;
	add     ebp, 230;                       factor de escala=0.9
	mov     eax, ebp;
	push    ebp;

	mov     ebp, edi
	sub     ebp, virtual
	add     ebp, virtual2

	shr     eax, 8;
	mul     FPUTemp1;
	mov     esi, eax;
	add     esi, zoom_start_y
	add     esi, virtual2;
	
	mov     edx, zoom_start_x;

@@horizontal:
	mov     eax, [esi+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi+ecx*2], bx;
	
	mov     eax, [esi-2+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-2+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-2+ecx*2], bx;

	mov     eax, [esi-4+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-4+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-4+ecx*2], bx;

	mov     eax, [esi-6+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-6+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-6+ecx*2], bx;

	mov     eax, [esi-8+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-8+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-8+ecx*2], bx;

	mov     eax, [esi-10+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-10+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-10+ecx*2], bx;

	mov     eax, [esi-12+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-12+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-12+ecx*2], bx;

	mov     eax, [esi-14+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-14+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-14+ecx*2], bx;

	mov     eax, [esi-16+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-16+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-16+ecx*2], bx;

	mov     eax, [esi-18+edx*2];
	and     eax, 1111011111011111b;
	mov     ebx, [ebp-18+ecx*2];
	and     ebx, 1111011111011111b;    
	add     ebx, eax;
	shr     ebx, 1;
	mov     [edi-18+ecx*2], bx;

	sub     edx, 9                       ;edx- textura
	sub     ecx, 10                      ;ecx- pantalla
	jns     @@horizontal

	add     edi, YS;
	pop     ebp;
	pop     edx;
	dec     edx;
	jnz     @@vertical;

	pop     ebp;

ret;



zoom_frame_asm_16_         ENDP

zoom_frame_asm_15_         PROC

;esi=virtual2;
;eax=i;
;edi=j;
;ebx=istep;
;edx=jstep;
;
;for (y=0; y<h; y++, j+=jstep)
;    for (x=0, i=((wt-w)>>1)*istep; x<w; x++, i+=istep) { 
;    temp=*((WORD *)(virtual2+(DWORD)(j)*w*2+(DWORD)(i)*2));
;    pPixel_16 (virtual+x*2 + w*y*2, temp);
;    }
;}

	push    ebp;

	mov virtual2, eax

	mov     edx, YR;
	mov     edi, virtual;
	mov     esi, virtual2;

	mov     eax, YS
	mov     FPUTemp1, eax;
	
	mov     eax, 0;
	mov     ebp, 0;

@@vertical1:
	mov     ecx, zoom_width;
	push    edx;
        add     ebp, 230;                       factor de escala=0.9
;                add ebp,153
	mov     eax, ebp;
	push    ebp;

	mov     ebp, edi
	sub     ebp, virtual
	add     ebp, virtual2

	shr     eax, 8;
	mul     FPUTemp1;
	mov     esi, eax;
	add     esi, zoom_start_y
	add     esi, virtual2;
	
	mov     edx, zoom_start_x;

@@horizontal1:
        mov     ebx, [esi+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi+ecx*2], bx;
	
        mov     ebx, [esi-2+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-2+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-2+ecx*2], bx;

        mov     ebx, [esi-4+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-4+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-4+ecx*2], bx;

        mov     ebx, [esi-6+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-6+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-6+ecx*2], bx;

        mov     ebx, [esi-8+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-8+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-8+ecx*2], bx;

        mov     ebx, [esi-10+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-10+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-10+ecx*2], bx;

        mov     ebx, [esi-12+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-12+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-12+ecx*2], bx;

        mov     ebx, [esi-14+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-14+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-14+ecx*2], bx;

        mov     ebx, [esi-16+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-16+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-16+ecx*2], bx;

        mov     ebx, [esi-18+edx*2];
;        and     eax, 111101111011111b;
;        mov     ebx, eax;
;        mov     ebx, [ebp-18+ecx*2];
;        and     ebx, 111101111011111b;
;        add     ebx, eax;
;        shr     ebx, 1;
	mov     [edi-18+ecx*2], bx;

        sub     edx, 9                       ;edx- textura
	sub     ecx, 10                      ;ecx- pantalla
	jns     @@horizontal1

	add     edi, YS;
	pop     ebp;
	pop     edx;
	dec     edx;
	jnz     @@vertical1;

	pop     ebp;

ret;



zoom_frame_asm_15_         ENDP



_TEXT ENDS

	END
